# -*- coding: UTF-8 -*-
# NVDA add-on for FunnyVoice
# by Marcos Antonio de Oliveira
# <mao-mail@uol.com.br>
import appModuleHandler
import controlTypes
import ui
import api
import addonHandler
import NVDAObjects
import winUser
import ctypes
#initialize translation
addonHandler.initTranslation()
def clickObject (location, rightMouseButton=False):
	(left, top, width, height) = (int(location[0]), int(location[1]), int(location[2]), int (location[3]))
		# Executa um click com o mouse num objeto
		# Se rightMouseButton = True, clica com o boto direito, caso contrrio clica com o esquerdo.
	if (left+top+width+height)>0:
		x=left+(width)/2
		y=top+(height)/2
		winUser.setCursorPos (x,y)
		if rightMouseButton:
			winUser.mouse_event(winUser.MOUSEEVENTF_RIGHTDOWN,0,0,None,None)
			winUser.mouse_event (winUser.MOUSEEVENTF_RIGHTUP,0,0,None,None)
		else:
			winUser.mouse_event(winUser.MOUSEEVENTF_LEFTDOWN,0,0,None,None)
			winUser.mouse_event (winUser.MOUSEEVENTF_LEFTUP,0,0,None,None)



class AppModule(appModuleHandler.AppModule):
	def event_NVDAObject_init(self,obj):
		pass

	def script_start (self, gesture):
		obj = self.getObject('Button', 'Start!')
		if obj is not None and not controlTypes.STATE_INVISIBLE in obj.states:
			clickObject (obj.location)
		else:
			ui.message (_('Start button not found'))
	def script_record (self, gesture):
		obj = self.getObject('Button', 'Record')
		n = 0
		if obj is None:
			obj = self.getObject('Button', 'Stop')
			n = 1
		if obj is not None and not controlTypes.STATE_INVISIBLE in obj.states:
			clickObject(obj.location)
			ui.message ([_('Recording...'), _('Stoped')][n])
		else:
			ui.message ([_('Record button not found'), _('Stop button not found')][n])


	def script_gotoDevicesCombo (self, gesture):
		n = gesture.mainKeyName == 'o'
		obj = self.getObject('ComboBox', None)
		if obj is not None and not controlTypes.STATE_INVISIBLE in obj.states:
			if n:
				obj = obj.simpleNext.simpleNext
			#api.setFocusObject(obj.parent)
			obj.parent.setFocus()
			#api.setFocusObject(obj)
			obj.setFocus()
		else:
			ui.message ([_('Input device combobox not found'), _('Output device combobox not found')][n])


	def script_changePitch (self, gesture):
		n = gesture.mainKeyName== 'leftArrow'
		obj = self.getObject ('Static', 'Plug in your microphone and listen to your funny voice!')
		if obj is not None and 'Pitch' in obj.simpleNext.simpleNext.name:
			obj = obj.simpleNext
			pitch = obj.simpleNext
			if not n:
				obj = obj.simpleNext.simpleNext
			clickObject (obj.location)
			ui.message (pitch.name)
		else:
			ui.message (_('Pitch controls not found'))

	def getObject (self, c, name):
		h = api.getForegroundObject().windowHandle
		h = ctypes.windll.user32.FindWindowExA(h, 0, c, name)
		if h:
			obj = NVDAObjects.IAccessible.getNVDAObjectFromEvent (h, -4, 0)
			return obj
		else:
			return None

	__gestures={
		"kb:CONTROL+S": "start",
		"kb:CONTROL+R": "record",
		"kb:CONTROL+i": "gotoDevicesCombo",
		"kb:CONTROL+o": "gotoDevicesCombo",
		"kb:ALT+LEFTARROW": "changePitch",
		"kb:ALT+RIGHTARROW": "changePitch",
	}
